#!/usr/bin/env python
#coding:cp866
"""
Wspomog. podprogrammy ob[ego nazna`eniq.
"""
import os,stat,time

def razbiwka(s):
 """ 'hui lai' -> ['hui','lai'] """
 s_=''
 for c in s:
  if c!='\t': s_+=c
  else: s_+=' '
 ss=s_.split(' ')
 ss=filter(lambda x:x!='',ss)
 return(ss)

def ubr_0d0a(s):
 """ 'huaxue\r\n' -> 'huaxue' """
 if s and s[-1]=='\n': s=s[:-1]
 if s and s[-1]=='\r': s=s[:-1]
 return(s)

def read_razbiw(f0):
 s=f0.readline()
 s=ubr_0d0a(s);
 ss=razbiwka(s)
 return(ss)

def time_string(t):
 format='%4d-%02d-%02d %02d:%02d:%02d'
 s=format % (t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 return(s)

def time_string_kurz(t):
 "Dlq ispolxz. kak dobawki k imenam sozdawaemyh fajlow."
 format='%4d%02d%02d_%02d%02d%02d'
 s=format % (t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 return(s)

def time_string_wday(t):
 sootw=['pn','wt','sr','`t','pt','sb','ws']
 format='%d,%d,%d (%s)'
 s=format % (t.tm_year,t.tm_mon,t.tm_mday,sootw[t.tm_wday])
 return(s)

def timestamp():
 t=time.localtime()
 s=time_string(t)
 return(s)

def timestamp_kurz():
 t=time.localtime()
 s=time_string_kurz(t)
 return(s)

def time_arr():
 t=time.localtime()
 a=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 return(a) 

def file_timestamp(imq):
 stati=os.stat(imq)
 t=time.localtime(stati.st_mtime)
 s=time_string(t)
 return(s)

def getftime(imq):
 stati=os.stat(imq)
 t=time.localtime(stati.st_mtime)
 a=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 return(a) 

def setftime(file1,file0):
 a0=os.stat(file0); a0_mtime=a0.st_mtime; a0_atime=a0_mtime;
 os.utime(file1, (a0_atime, a0_mtime))

def setftime_(file1,y,mo,d,h,m,s):
 time_=time.mktime((y,mo,d,h,m,s,-1,-1,-1))
 os.utime(file1, (time_, time_))

def htm_shapka(coding='???',title='xxx'):
 s1a='<meta http-equiv="content-type" content="text/html; charset='
 s1b='">\n'
 if coding!='???':
  s1= s1a+coding+s1b
 else:
  s1= s1a+'cp866'+s1b
  s1+=s1a+'windows-1251'+s1b
  s1+=s1a+'utf-8'+s1b
 s2='<title>'+title+'</title>\n'
 s3='<font size=+4>\n'
 s4='<pre>\n'
 s=s1+s2+s3+s4
 return(s)

def zamen_c(s,c0,c1):
 "W stroke 's' simwol c0 zamen. na c1."
 s_=''
 for c in s:
  c_=c
  if c==c0: c_=c1
  s_+=c_
 return(s_)

def dlq_imeni(c):
 """
 Simwoly, neprigodnye dlq im@n fajlow, zamenqem na '_'. 
 """
 c_='_'
 i=ord(c)
 if i>=ord('a') and i<=ord('z'): c_=c
 if i>=ord('A') and i<=ord('Z'): c_=c
 if i>=ord('0') and i<=ord('9'): c_=c
 if c in ['.','-','_']: c_=c
 return(c_)

def str_imq(s0):
 """
 ~toby ispolxz. stroku w ka`-we imeni fajla, zamenqem
 nedopustimye simwoly na '_'.  
 """
 s1=''
 for c0 in s0:
  c1=dlq_imeni(c0)
  s1+=c1
 return(s1)

def test_c(c):
 g1 = (ord(c)<0x20) and (c in '\t\n\r')
 g2 = ord(c)>=0x20 and ord(c)<=0x7E  
 # 7F - wrode specsimwol neqsnogo nazna`eniq.
 g3 = ord(c)>=0x80
 return(g1,g2,g3)

def test_str(s):
 """
 Zamysel: pri kopir. fajlow `erez fle[ku bywaet, `to `astx 
 bajtow zamenqetsq musorom; pytaemsq prowerqtx stroki,
 `toby wylowitx takie slu`ai. 
 """
 gut_lat,gut_kir = True,True
 for c in s:
  g1,g2,g3 = test_c(c)
  if not (g1 or g2): gut_lat=False
  if not (g1 or g2 or g3): gut_kir=False
 return(gut_lat,gut_kir)

def printable(c):
 c_='.'
 i=ord(c)
 if i>=0x20 and i<=0x7E: c_=c
 return(c_)

def printable_866(c):
 c_='.'
 i=ord(c)
 gut=i>=0x20 and i<=0x7E
 gut=gut or i>=0x80 and i<=0xAF
 gut=gut or i>=0xE0 and i<=0xEF
 gut=gut or i>=0xF0 and i<=0xF1
 if gut: c_=c
 return(c_)

def printable_s(s):
 s_=''
 for c in s: s_+=printable(c)
 return(s_)

def printable_866_s(s):
 s_=''
 for c in s: s_+=printable_866(c)
 return(s_)

def dump_s(s):
 s_=''
 for c in s: s_+=('%02X' % (ord(c),))
 return(s_)

def dump_s_(s):
 s_=''
 for c in s: s_+=('%02X ' % (ord(c),))
 return(s_)

def dump16(adr0,s,imq=''):
 """
 adr0 - adres w fajle, s k-rogo byl pro`itan fragment 's'.
 """
 print '--------\\'
 if imq: print 'imq=',imq
 # print 'len(s)=',len(s)
 ostat=s[:]
 while True:
  haj=ostat[:16]; ostat=ostat[16:]
  sd=dump_s(haj)
  while len(sd)<32: sd+=' '
  sd=sd[0:8]+' '+sd[8:16]+' '+sd[16:24]+' '+sd[24:32]
  print '%08X / %s / %s' % (adr0,sd,printable_s(haj))
  adr0+=16
  if len(ostat)==0: break
 print '--------/'

def dump4(adr0,s,imq=''):
 """
 adr0 - adres w fajle, s k-rogo byl pro`itan fragment 's'.
 """
 print '--------\\'
 if imq: print 'imq=',imq
 # print 'len(s)=',len(s)
 ostat=s[:]
 while True:
  haj=ostat[:4]; ostat=ostat[4:]
  sd=dump_s(haj)
  while len(sd)<8: sd+=' '
  print '%08X / %s / %s' % (adr0,sd,printable_s(haj))
  adr0+=4
  if len(ostat)==0: break
 print '--------/'

def zapis_w_fajl(s,imq,revim='ab'):
 f1=open(imq,revim)
 f1.write(s+'\n')
 f1.close()

def zapis(obxekt, filename='raboch.txt'):
 f1=open(filename,'ab')
 s=str(obxekt)
 f1.write(s+'\n')
 f1.close()

def ww_param(imq):
 "Wwod parametra iz fajla."
 f0=open(imq,'r')
 s=f0.readline()
 f0.close()
 s=ubr_0d0a(s)
 assert len(s)!=0
 return(s)

def sort_xy(xx,yy):
 "Sortirowka to`ek po wozrast. x dlq risowaniq grafika w pylab'e."
 xy=map(lambda x,y:(x,y),xx,yy)
 xy.sort()
 xx=map(lambda x:x[0],xy)
 yy=map(lambda x:x[1],xy)
 return(xx,yy)

def razbor_xy(xy):
 "Razbiwka massiwa xy na xx i yy dlq risowaniq grafika w pylab'e."
 xx=map(lambda x:x[0],xy)
 yy=map(lambda x:x[1],xy)
 return(xx,yy)

def sozd_xy(xx,yy):
 "sozd_xy([1,2], [10,20]) -> [(1, 10), (2, 20)]."
 xy=map(lambda x,y:(x,y),xx,yy)
 return xy

def repr_(DD,imq): 
 "Wywod spiska dlq wstawki w dr. programmy."
 s=imq+'=['
 for D in DD: s+=('%8.6f, ' % D)
 s=s[:-2] # srez. ', ' w konce
 s+=']'
 print s
 return(s)

def file_ari(imq):
 "Prowerka nali`iq (i dostupnosti) fajla."
 ari=False
 try: f=open(imq,'rb'); f.close(); ari=True
 except: pass
 return(ari)

def file_zerolength(imq):
 if not file_ari(imq):
  # raise OSError('file_zerolength: '+imq+' - not file_ari')
  # print imq,'not ari'
  return(False)
 stati=os.stat(imq)
 mode=stati[stat.ST_MODE]
 siz=stati[stat.ST_SIZE]
 gut=stat.S_ISREG(mode) and siz==0
 # print imq,mode,siz,gut
 return(gut)

def modif_imq(imq0,dobawka='_lat'):
 """
 Napr., dlq modif. imeni fajla pri transliteracii latinicej. 
 aaa.bbb.ccc.xml   11  -> aaa.bbb.ccc_lat.xml
 aaa.bbb.ccc.xml.  15  -> aaa.bbb.ccc.xml_lat.
 aaabbbccc          9  -> aaabbbccc_lat   
 """
 n=-1
 for i in range(len(imq0)):
  if imq0[i]=='.': n=i
 if n==-1: n=len(imq0)
 imq_lat=imq0[:n]+dobawka+imq0[n:]
 # print '%-16s  %2d  -> %-16s' % (imq0,n,imq_lat)
 return(imq_lat)

def sozd_dir(x_dir):
 """
 Sozdanie kataloga s prowerkami.
 Prosto os.mkdir(x_dir) - esli katalog uve imeetsq, -> o[.
 Prowereno: popytka sozd. srazu cepo`ku katalogow -> WindowsError,
 i ne sleduet ot \\togo izbawlqtxsq, t.k. togda o[ibka pri zadanii
 takoj cepo`ki ostanetsq ne wylowlennoj, a potom wyloowitx e@
 budet slovnee. 
 """
 try: stati=os.stat(x_dir)
 except: stati=None
 if stati: mode=stati[stat.ST_MODE]
 else: mode=None
 if stati and not stat.S_ISDIR(mode):
  s_err=x_dir+' - imeetsq i ne qwlqetsq katalogom !!!'
  print s_err
  raise OSError(s_err)
 elif not stati:  # Katalog otsutstwowal.
  os.mkdir(x_dir)
  stati=os.stat(x_dir)  # Prower., `to katalog sozdalsq.
  mode=stati[stat.ST_MODE]
  assert stat.S_ISDIR(mode)

def int_(s):
 "Dlq int(s) nado udalitx wedu[ie nuli."
 while len(s)>1 and s[0]=='0': s=s[1:]
 # if s=='': s='0'
 i=int(s)
 return(i)

def float_(s0):
 "s0 - iz *.CSV s osc-grafa; nado ',' zamen. na '.'."
 s=''
 for c in s0:
  if c!=',': s+=c
  else: s+='.'
 try: r=float(s)
 except: print 'float_: s=',repr(s),'- !!!'; raise
 return(r)

def min_(xx):
 """
 Pustx w serii izmerenij `astx propu]ena; wmesto nih dlq
 sograneniq numeracii wpisano None; i esli hotim izobr. 
 normir. grafik, pri popytke najti min okaz. min=None.
 Po\tomu wmesto min(xx) prihoditsq sozdatx dann. min_(xx).
 """
 m=xx[0]
 for x in xx:
  if x!=None and x<m: m=x
 return(m)

def get_siz_tim(poln_imq):
 "Dlq fajla ili kataloga - izwlek. size i time."
 # print 'get_siz_tim: poln_imq=',poln_imq
 stati=os.stat(poln_imq)
 mode=stati.st_mode
 is_dir_=stat.S_ISDIR(mode)
 siz=stati.st_size
 if is_dir_: siz=None
 t_int=stati.st_mtime
 t=time.localtime(t_int) # Sodervit neispolxzuemye polq.
 tim=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 siz_tim=(siz,tim)
 return(siz_tim)

def file_stat(katalog,imq):
 "Dlq sowmestimosti so starymi prog-mami."
 if katalog!='':
  poln_imq=katalog+'/'+imq
 else:
  poln_imq=imq
 siz_tim=get_siz_tim(poln_imq)
 return(siz_tim)

def readline_win(f):
 """
   f.readline() pod Windows ustanawliwaetsq ne na konec 
 pro`itannoj stroki, a na neponqtno kak wybiraemu; pozici;,
 i wernutxsq k na`alu predydu]ej stroki okaz. newozm.;
 dann. podprog. ustanawliwaeet prawilxnu; pozici;.
 """
 p0=f.tell()
 s=f.readline()
 p1_=f.tell()
 p1=p0+len(s)
 f.seek(p1)
 # print 'readline_win: %08X %08X' % (p1_ & 0xFFFFFFFF,p1 & 0xFFFFFFFF)
 # Bez '& 0xFFFFFFFF' wmesto FFFFFFFD wyda@t -0000003 !
 return(s)

def readline_(f0):
 """
 1A - pri `tenii po readline - priznak konca; izobr. kak strel. wprawo;
 1B - izobr. kak strel. wlewo.
 Realxno popalosx, kak w *.txt (wozm., na wyh. 'lynx''a)
 \timi simwolami izobr. strelo`ki.
 Zamenqem ih na '-', `toby w dalxnej[em ne polu`. dosro`nogo
 prekra]eniq obrabotki fajla.
 """
 # global n
 # print '-'*8
 s=''
 while True:
  c=f0.read(1)
  # print repr(c)
  if c=='': break
  if ord(c) in ([0x1A,0x1B]): c='-'
  s+=c
  if c=='\n': break
 # n+=1
 # print n,repr(s)
 return(s)

def sraw_files_utocn(s1,s2):
 """
 s1,s2 - stroki, pro`itannye iz srawniwaemyh fajlow;
 wozwr. adres perwogo nesowp. bajta i sami nesowp. bajty.
 """
 l1=len(s1); l2=len(s2)
 assert l1==l2
 for i in range(l1):
  g=s1[i]==s2[i]
  if not g: break
 return((i,s1[i],s2[i]))

def sraw_files(imq1,imq2):
 """
 imq1 i imq2 - polnye imena fajlow.
 Wozwr. zna`.:
 (siz1,siz2) => ne sowp. razmer;
 adr,c1,c2 => po adr. 'adr' nah. nesowp. bajt c1!=c2;
 True => fajly sowp.
 """
 treb=8192*16
 # print imq1,imq2
 siz1,tim1 = get_siz_tim(imq1)
 siz2,tim2 = get_siz_tim(imq2)
 if siz2!=siz1: return((siz1,siz2))
 f1=open(imq1,'rb')
 f2=open(imq2,'rb')
 ostatok=siz1; p=0; i_=None; gut=True
 # gut=True - neobh. dlq siz1=siz2=0.
 while True:
  if ostatok<treb: treb=ostatok
  if treb==0: break
  # print '%08X' % (p,)
  s1=f1.read(treb); s2=f2.read(treb)
  # print repr(s1)
  # print repr(s2)
  gut=s1==s2
  # print gut
  if not gut:
   i,c1,c2=sraw_files_utocn(s1,s2);
   # print i,repr(c1),repr(c2)
   break
  ostatok-=treb; p+=treb
 f2.close()
 f1.close()
 if gut: result=True
 else: result=(p+i,ord(c1),ord(c2))
 return(result)

def pois_substr(imq,substri, n=20):
 """
 W na`ale fajla i]em stroku, sod. zadann. podstroku. 
 n<=0 -> prower. wse stroki, n>0 - tk. perwye n strok.
 """
 f0=open(imq,'r')
 gef=False
 m=0
 while True:
  m+=1
  if n>0 and m>n: break
  s=f0.readline()
  if s=='': break
  i = s.find(substri)
  if i>-1: gef=True; break
 f0.close()
 return(gef)

# --------

"""
  Zamysel: s u`@tom "letnego wremeni" daty "uplywa;t",
napr., ustanawliwaem sohran@nnu; w arhiwe po tipu 
"2016-05-08 11:34:26" datu fajla - i ona tut ve otobravaetsq 
sdwinutoj na `as; po\tomu predlag. w fajlah u`@ta hranitx daty 
w linuksowskom formate - kak `islo sekund s na`ala 1970-go goda.
Nive - podprog. dlq raboty s hranq]imisq podobnym obrazom datami.
"""

def time_current_hex():
 t_int=time.time()
 st='%08X' % (int(t_int) & 0xFFFFFFFF,)
 return(st)

def time_hex_norm(st):
 format_time='%4d-%02d-%02d %02d:%02d:%02d'
 st='0x'+st
 t_int=int(st,16)
 t=time.localtime(t_int) # soderv. neispolxzuemye polq
 tim=(t.tm_year,t.tm_mon,t.tm_mday,t.tm_hour,t.tm_min,t.tm_sec)
 s=format_time % tim[:6]
 return(tim,s)

def show_time_hex():
 "Dlq zapolneniq polej 'created' i 'last_modif' wru`nu;."
 st=time_current_hex()
 tim,s=time_hex_norm(st)
 print 'show_time:',s,'->',st

months={
 'Jan':1, 'Feb':2, 'Mar':3, 'Apr':4, 'May':5, 'Jun':6,
 'Jul':7, 'Aug':8, 'Sep':9, 'Oct':10, 'Nov':11, 'Dec':12, 
}

def wosst_datu(s):
 """
 s = data w formate, kak w *.doc s \l. mikroskopa u ~ugina -
 "Mon Apr 16 15:45:49 2018";
 hotim preobr. w (2018,4,16,15,45,49).
 """
 ss = razbiwka(s); # print ss
 y = int(ss[4])
 mo = months[ss[1]]
 d = int(ss[2])
 hms=ss[3].split(':')
 h,m,s = map(int,hms)
 resu = (y,mo,d,h,m,s)
 return(resu)

# --------

def izobr_long_list(xx):
 """
 Dlq otlado`nogo wywoda dlinn. spiskow po tipu
 [1, 2, 3, 4, ..., 7, 8, 9, 10] .
 """
 s='['
 used_xxx=False
 n=len(xx)
 for i in range(n):
  if i<=3 or i>=n-4: s+=(str(xx[i])+', ')
  else:
   if not used_xxx: s+='..., '; used_xxx=True
 s=s[:-2]+']'
 return(s)

def sort_xy(xx,yy):
 xy=map(lambda x,y:(x,y), xx,yy)
 xy.sort()
 xx_=map(lambda x: x[0], xy)
 yy_=map(lambda x: x[1], xy)
 return(xx_,yy_)

# --------

# Simwoly kawy`ek w 'lat' zamenqem simwolami dollara,
# t.k. pri kawy`ki pri posled. obrabotke m.b. wosprinqty
# kak priznak konca stroki. 
# Tv. dobawlen simwol nomera, wstre`. w zakazah s Aliexpress'a.

alt="""




"""
lat="""
ABWGDEVZIJKLMNOPRSTUFHC~{}$YX|#Q
abwgdevzijklmnoprstufhc`[]$yx\$q
&@EeIiUuGg
N
"""

def alt_lat(s0):
 s1=''
 for c0 in s0:
  n=alt.find(c0)
  c1=c0
  if n>-1: c1=lat[n]
  s1+=c1
 return(s1)

def okrugl_wspomo(x):
 if x>=0: r = int(x*1e6+0.5)*1e-6
 else:    r = -int(-x*1e6+0.5)*1e-6
 return(r) 

def okrugl(x):
 """
 Okruglenie:
 150528.00000000012 -> 150528.0,
 56.000000000000206+55.99999999999993j -> 56+56j .
 Nedostatok: bywaet, `to okruglqet, no pri wyw. okrugl@nnogo `isla
 snowa podbrasywaet hwost - po tipu
 0.8106788429054055 -> 0.8107000000000001 .
 W prostyh slu`aqh (napr., dlq spiska) predlag. napisatx f-ci;
 preobr. ob\ekta w stroku, w k-roj `isla okrugl. `erez strokowye predst.
 A w ob]em slu`ae, kogda `isla nah. w glubine struktur - 
 obrabatywatx struktury rekursiwno. 
 """
 if type(x)==type(2.4):
  r=okrugl_wspomo(x)
 elif type(x)==type(2.4+2.4j):
  a=x.real; b=x.imag
  ra=okrugl_wspomo(a)
  rb=okrugl_wspomo(b)
  r=complex(ra,rb)
 else:
  r=x
 return(r)   

def okrugl_s1(pp):
 "pp - spisok `isel."
 s = '['
 for p in pp:
  sp = '%8.6f' % (p,)
  while sp.endswith('0'): sp=sp[:-1]
  s = s+sp+', '
 s=s+']'
 return(s)

def ww_xy(imq):
 """
 Wwod, napr., *.spe ot Pikulewa - 
 kogda estx stroki wida '377.1\t10290'.
 """
 xx,yy = [],[]
 f0=open(imq,'rb')
 while True:
  s=f0.readline()
  if s=='': break
  s=ubr_0d0a(s)
  ss=razbiwka(s)
  try:
   ss=map(float,ss)
   x,y = ss
   xx.append(x); yy.append(y)
  except:
   pass
 return(xx,yy)
  
def zapis_xy(obozn,xx,yy):
 f1=open('tempor.py','ab')
 f1.write('# --------\n')
 f1.write('obozn='+repr(obozn)+'\n')
 f1.write('xx='+str(xx)+'\n')
 f1.write('yy='+str(yy)+'\n')
 f1.write('\n')
 f1.close()

def ogranic(ff,fmin,fmax):
 "Ograni`enie \lementow spiska ff."
 ff_=[]
 for i in range(len(ff)):
  f = ff[i]
  if f<fmin: f=fmin
  if f>fmax: f=fmax
  ff_.append(f)
 return(ff_)

# --------

if __name__=='__main__':
 ss = dir()
 for s in ss: print s
