"""
  U nas disk okazalsq rame`en po tipu GPT 
(w MBR - edinstwenn. radel tipa 0xEE == GPT).
  Pytaemsq ego analizirowatx.
  Ss.: https://wiki.osdev.org/GPT .
  Posr-wom anal_MBR wyqsn., `to sektor so sme]. 0 - MBR,
a na`inaq so sme]. 1 - upomqnutyj razdel tipa GPT.
  Udalosx uwidetx razbiwku GPT-razdela, no razdely dannyh
wnutri GPT-razdela okazalisx za predelami sohran@nnogo 
fragmenta (a disk otdan hozqinu). Kakie iz razdelow dannyh - 
tipa NTFS - iz sohran@nnogo fragmenta neqsno (no, wozm.,
\to udastsq ponqtx iz sobstw. zapisej - `astx fajlow
udalosx wosstanowitx), i wo wsqkom slu`ae sami razdely
dannyh w sohran@nnom fragmente otsutstwu;t.
"""
from geral import printable_s,dump_s_
import sys,struct

imq='dupa5b.dat'

# --------

def read_sec(imq,n):
 print '----- read_sec '+str(n)+' -----\\'
 ofs=512*n
 print '%s %d %08X' % (repr(imq),n,ofs)
 f0=open(imq,'rb')
 f0.seek(ofs)
 s=f0.read(512)
 f0.close()
 print '----- read_sec '+str(n)+' -----/'
 return(s)

def anal_gpt(s):
 print '----- anal_gpt -----\\'
 n=512-0x5C
 sn=str(n)
 specif='8sLLLLQQQQ16sQLLL'+sn+'s'
 # print repr(specif)
 hh=struct.unpack(specif,s)
 # print hh
 sign,revision,hea_siz,check1,rese1,lba1,lba2,lba_first,lba_last,\
   guid,lba_guid,n_partit,size_entry,crc_entry,hoka=hh
 print repr(sign)
 assert sign=='EFI PART'
 # print '%08X' % (revision,)
 # print '%08X - header size' % (hea_siz,)
 # print '%08X' % (check1,)
 # print '%08X' % (rese1,)
 # print 'lba=%08X %08X %08X %08X' % (lba1,lba2,lba_first,lba_last)
 # print repr(guid)
 print 'lba_guid= %08X' % (lba_guid,)
 assert lba_guid==2
 print 'n_partit,size_entry=',n_partit,size_entry
 # print '%08X - crc_entry' % (crc_entry,)
 for c in hoka: assert c==chr(0)
 print '----- anal_gpt -----/'
 return(lba_guid,n_partit,size_entry)

def anal_opis_partit(imq,lba_guid,size_entry,nr):
 # print '----- anal_opis_partit '+str(nr)+' -----\\'
 assert lba_guid==2
 ofs = 512*lba_guid + nr*size_entry
 f0=open(imq,'rb')
 f0.seek(ofs)
 s=f0.read(size_entry)
 f0.close()
 specif='16s16sQQQ72s'
 hh=struct.unpack(specif,s)
 guid1,guid2,lba0,lba1,atrib,imq_=hh
 if lba0!=0:
  print ''
  print 'nr,ofs,size_entry=%3d %08X %02X' % (nr,ofs,size_entry)
  # print '%02X %02X ' % (ord(s[0]),ord(s[1]))
  # print repr(guid1)
  # print repr(guid2)
  size_Gb=((lba1-lba0+1)*512)/1024.**3
  # print '%016X - lba0' % (lba0,)
  # print '%016X - lba1' % (lba1,)
  print 'lba0,lba1 = %016X..%016X -> %6.1f Gb' % (lba0,lba1,size_Gb)
  # print '%016X - atrib' % (atrib,)
  print repr(ubr_nuli(imq_))

  # Esli analiziruetsq wyrezannoe na`alo obraza diska:
  # popytka 'seek' -/-> err., i f0.tell -> adres za predelami,
  # i tk. read -> stroku dliny 0. 
  f0=open(imq,'rb')
  ofs0=lba0*512
  f0.seek(ofs0)
  s=f0.read(16)
  f0.close()
  if len(s)==16:
   print 'ofs0 = %08X' % (ofs0,)
   print dump_s_(s),'/',printable_s(s)
  else:
   print 'Razdel - za predelami wyrezannogo obraza.' 
 else:
  # print '%d %08X - unused.' % (nr,ofs)
  pass
 # print '----- anal_opis_partit '+str(nr)+' -----/'

def ubr_nuli(s0):
 s=''
 for c in s0:
  if c!=chr(0): s+=c
 return(s)

# --------

s_GPT = read_sec(imq,1)
lba_guid,n_partit,size_entry = anal_gpt(s_GPT)
# -> 2, 128, 128 .
for nr in range(n_partit): 
 # print 'nr=',nr
 anal_opis_partit(imq,lba_guid,size_entry,nr)

"""
# 1-j razdel, 1-j sektor.
s=read_sec(imq,0x800)
f1=open('dupa800.dat','wb')
f1.write(s)
f1.close()
"""

# --------


